var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Color3, StandardMaterial } from "@babylonjs/core";
var AdvancedDynamicTextureLifecycleListener = /** @class */ (function () {
    function AdvancedDynamicTextureLifecycleListener(scene, props) {
        this.scene = scene;
        this.props = props;
    }
    AdvancedDynamicTextureLifecycleListener.prototype.onParented = function (parent, child) { };
    AdvancedDynamicTextureLifecycleListener.prototype.onChildAdded = function (child, parent) { };
    AdvancedDynamicTextureLifecycleListener.prototype.onMount = function (instance) {
        this.addControls(instance);
        if (instance.customProps.createForParentMesh) {
            // console.log('for parent mesh', instance.parent ? instance.parent.babylonJsObject : 'error: no parent object')
            var mesh = instance.parent.hostInstance; // should crawl parent hierarchy for a mesh
            // console.error('we will be attaching the mesh:', mesh.name, mesh);
            var material = new StandardMaterial("AdvancedDynamicTextureMaterial", mesh.getScene());
            material.backFaceCulling = false;
            material.diffuseColor = Color3.Black();
            material.specularColor = Color3.Black();
            if (instance.hostInstance === undefined) {
                console.error('missing instance');
            }
            else {
                if (this.props.hasAlpha) {
                    material.diffuseTexture = instance.hostInstance;
                    material.emissiveTexture = instance.hostInstance;
                    instance.hostInstance.hasAlpha = true;
                }
                else {
                    material.emissiveTexture = instance.hostInstance;
                    material.opacityTexture = instance.hostInstance;
                }
            }
            mesh.material = material;
            // set to true unless explicitly not wanted.
            // connects the texture to a hosting mesh to enable interactions
            var supportPointerMove = this.props.supportPointerMove !== false ? true : false;
            instance.hostInstance.attachToMesh(mesh, supportPointerMove);
        }
    };
    AdvancedDynamicTextureLifecycleListener.prototype.addControls = function (instance) {
        var _this = this;
        // When there is a panel, it must be added before the children. Otherwise there is no UtilityLayer to attach to.
        // This project before 'react-reconciler' was added from parent up the tree.  'react-reconciler' wants to do the opposite.
        instance.children.forEach(function (child) {
            if (child.metadata.isGUI2DControl === true) {
                instance.hostInstance.addControl(child.hostInstance);
                child.state = { added: true };
            }
        });
        if (instance.customProps.connectControlNames !== undefined && Array.isArray(instance.customProps.connectControlNames)) {
            var controlNames = instance.customProps.connectControlNames;
            var root = instance;
            while (root.parent !== null) {
                root = root.parent;
            }
            this.connect(instance, root, controlNames);
        }
        instance.children.forEach(function (child) {
            _this.addControls(child);
        });
    };
    AdvancedDynamicTextureLifecycleListener.prototype.connect = function (keyboard, searchInstance, controlNames) {
        var _this = this;
        if (searchInstance.metadata.isGUI2DControl && searchInstance.hostInstance && controlNames.indexOf(searchInstance.hostInstance.name) !== -1) {
            // console.log(keyboard.hostInstance, '.connect(->', searchInstance.hostInstance)
            keyboard.hostInstance.connect(searchInstance.hostInstance);
        }
        searchInstance.children.forEach(function (child) {
            return _this.connect(keyboard, child, controlNames);
        });
    };
    AdvancedDynamicTextureLifecycleListener.prototype.onUnmount = function () { };
    return AdvancedDynamicTextureLifecycleListener;
}());
export default AdvancedDynamicTextureLifecycleListener;
/**
 * This is attached by convention in react-reconciler HostConfig.
 */
var ADTFullscreenUILifecycleListener = /** @class */ (function (_super) {
    __extends(ADTFullscreenUILifecycleListener, _super);
    function ADTFullscreenUILifecycleListener() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return ADTFullscreenUILifecycleListener;
}(AdvancedDynamicTextureLifecycleListener));
export { ADTFullscreenUILifecycleListener };
//# sourceMappingURL=AdvancedDynamicTextureLifecycleListener.js.map