var BehaviorLifecycleListener = /** @class */ (function () {
    function BehaviorLifecycleListener() {
        this.behaviorAware = null;
        this.behavior = null;
    }
    BehaviorLifecycleListener.prototype.onParented = function (parent, child) {
        var _a;
        if (parent.metadata.isNode && ((_a = parent.hostInstance) === null || _a === void 0 ? void 0 : _a.addBehavior) /* TODO: verify if this needs to be a mesh */ && child.metadata.isBehavior /* always true? */) {
            parent.hostInstance.addBehavior(child.hostInstance);
            this.behaviorAware = parent.hostInstance;
            this.behavior = child.hostInstance;
        }
        else {
            console.warn('Could not locate IBehaviorAware on Behavior parent.');
        }
    };
    BehaviorLifecycleListener.prototype.onChildAdded = function (parent, child) { };
    BehaviorLifecycleListener.prototype.onMount = function (instance) { };
    BehaviorLifecycleListener.prototype.onUnmount = function () {
        if (this.behaviorAware) {
            this.behaviorAware.removeBehavior(this.behavior);
        }
    };
    return BehaviorLifecycleListener;
}());
export default BehaviorLifecycleListener;
//# sourceMappingURL=BehaviorsLifecycleListener.js.map