var CameraLifecycleListener = /** @class */ (function () {
    function CameraLifecycleListener(scene, props, canvas) {
        this.props = props;
        this.canvas = canvas;
        this.scene = scene;
    }
    CameraLifecycleListener.prototype.onParented = function (parent, child) {
        if (parent.metadata.isNode && child.metadata.isNode) {
            // TODO: consider add option for setParent(), which parents and maintains mesh pos/rot in world space
            // child.hostInstance.setParent(parent.hostInstance)
            child.hostInstance.parent = parent.hostInstance;
        }
    };
    CameraLifecycleListener.prototype.onChildAdded = function (child, parent) { };
    CameraLifecycleListener.prototype.onMount = function (instance) {
        if (instance.hostInstance === undefined) {
            console.error('Missing instance');
            return;
        }
        // prevent default unless explicitly specified.
        var camera = instance.hostInstance;
        var noPreventDefault = this.props.noPreventDefault === false ? false : true;
        // console.log("camera.attachControl:", camera, this.canvas, noPreventDefault)
        // should be a custom property for autoAttaching?  Will be an issue for multiple cameras.
        camera.attachControl(this.canvas, noPreventDefault);
        if (instance.metadata.isTargetable && this.props.lockedTargetMeshName) {
            if (this.scene === null) {
                console.error("no scene for targeting");
            }
            else {
                var targetCamera = camera;
                targetCamera.lockedTarget = this.scene.getMeshByName(this.props.lockedTargetMeshName);
            }
        }
    };
    CameraLifecycleListener.prototype.onUnmount = function () { };
    return CameraLifecycleListener;
}());
export default CameraLifecycleListener;
//# sourceMappingURL=CameraLifecycleListener.js.map