import { applyInitialPropsToInstance } from "../UpdateInstance";
var DeferredCreationLifecycleListener = /** @class */ (function () {
    function DeferredCreationLifecycleListener(scene, props) {
        this.scene = scene;
        this.props = props;
    }
    DeferredCreationLifecycleListener.prototype.onMount = function (instance) {
        var createdInstance = this.createInstance(instance, this.scene, this.props);
        if (createdInstance === undefined) {
            console.warn('was unable to create deferred instance');
        }
        else {
            // Meed to assign deferred props (from delayed creation) or they are lost:
            if (instance.deferredCreationProps && instance.propsHandlers) {
                applyInitialPropsToInstance(instance, instance.deferredCreationProps);
            }
            else {
                console.warn('cannot assign deferred props.  they are lost.');
            }
            instance.deferredCreationProps = undefined;
        }
    };
    return DeferredCreationLifecycleListener;
}());
export default DeferredCreationLifecycleListener;
//# sourceMappingURL=DeferredCreationLifecycleListener.js.map