var EnvironmentHelperLifecycleListener = /** @class */ (function () {
    function EnvironmentHelperLifecycleListener(scene, props) {
        this.scene = scene;
        this.props = props;
    }
    EnvironmentHelperLifecycleListener.prototype.onParented = function (parent, child) { };
    EnvironmentHelperLifecycleListener.prototype.onChildAdded = function (child, parent) { };
    EnvironmentHelperLifecycleListener.prototype.onMount = function (instance) {
        if (instance.hostInstance === undefined) {
            console.error('Missing instance');
            return;
        }
        // for TypeScript people use <... setMainColor={[mainColor]} />
        if (this.props.mainColor) {
            instance.hostInstance.setMainColor(this.props.mainColor);
        }
        if (this.props.teleportEnvironmentGround) {
            console.error("need to enable teleportation to ground (also from VRExperienceHelper, so call order has no impact.");
        }
    };
    EnvironmentHelperLifecycleListener.prototype.onUnmount = function () { };
    return EnvironmentHelperLifecycleListener;
}());
export default EnvironmentHelperLifecycleListener;
//# sourceMappingURL=EnvironmentHelperLifecycleListener.js.map