import { VirtualKeyboard } from "@babylonjs/gui/2D/controls/virtualKeyboard";
var GUI2DControlLifecycleListener = /** @class */ (function () {
    function GUI2DControlLifecycleListener() {
    }
    GUI2DControlLifecycleListener.prototype.onParented = function (parent, child) { };
    GUI2DControlLifecycleListener.prototype.onChildAdded = function (child, parent) { };
    GUI2DControlLifecycleListener.prototype.onMount = function (instance) {
        if (instance === undefined) {
            console.error('Missing instance');
            return;
        }
        if (instance.customProps.defaultKeyboard === true) {
            if (instance.hostInstance instanceof VirtualKeyboard) {
                // TODO: Generate from factory method.  VirtualKeyboard.CreateDefaultLayout()
                instance.hostInstance.addKeysRow(["1", "2", "3", "4", "5", "6", "7", "8", "9", "0", "\u2190"]);
                instance.hostInstance.addKeysRow(["q", "w", "e", "r", "t", "y", "u", "i", "o", "p"]);
                instance.hostInstance.addKeysRow(["a", "s", "d", "f", "g", "h", "j", "k", "l", ";", "'", "\u21B5"]);
                instance.hostInstance.addKeysRow(["\u21E7", "z", "x", "c", "v", "b", "n", "m", ",", ".", "/"]);
                instance.hostInstance.addKeysRow([" "], [{ width: "200px" }]);
            }
        }
        if (instance.state && instance.state.added === true) {
            return;
        }
        var addedParent = null;
        var tmp = instance.parent;
        while (tmp) {
            if (tmp.metadata.isGUI2DControl) {
                if (tmp.state && tmp.state.added === true) {
                    addedParent = tmp;
                    break;
                }
            }
            tmp = tmp.parent;
        }
        if (addedParent) {
            this.addControls(addedParent);
        }
    };
    GUI2DControlLifecycleListener.prototype.addControls = function (instance) {
        var _this = this;
        instance.children.forEach(function (child) {
            if (child.metadata.isGUI2DControl === true) {
                // console.warn("calling ", instance.hostInstance.name, ".addControl(", child.hostInstance.name, ")")
                instance.hostInstance.addControl(child.hostInstance);
                child.state = { added: true };
            }
        });
        if (instance.customProps.connectControlNames !== undefined && Array.isArray(instance.customProps.connectControlNames)) {
            // let controlNames: string[] = instance.customProps.connectControlNames
            var root = instance;
            while (root.parent !== null) {
                root = root.parent;
            }
        }
        instance.children.forEach(function (child) {
            _this.addControls(child);
        });
    };
    GUI2DControlLifecycleListener.prototype.onUnmount = function () { };
    return GUI2DControlLifecycleListener;
}());
export default GUI2DControlLifecycleListener;
//# sourceMappingURL=GUI2DControlLifecycleListener.js.map