var MaterialsLifecycleListener = /** @class */ (function () {
    function MaterialsLifecycleListener() {
    }
    MaterialsLifecycleListener.prototype.onCreated = function (instance, scene) {
        if (instance.customProps.attachToMeshesByName) {
            if (!Array.isArray(instance.customProps.attachToMeshesByName)) {
                console.error("AttachToMeshesByName must be an array (of strings).", instance.customProps.attachToMeshesByName);
                return;
            }
            if (instance.hostInstance === undefined) {
                console.error('instance not assigned');
                return;
            }
            var meshNamesToAttachTo_1 = instance.customProps.attachToMeshesByName.slice(0);
            // TODO: also need a listener for models or if we want to add a predicate:
            scene.onNewMeshAddedObservable.add(function (mesh) {
                if (meshNamesToAttachTo_1.indexOf(mesh.name) >= 0) {
                    setTimeout(function () {
                        mesh.material = instance.hostInstance;
                    }, 0);
                }
            });
            scene.meshes.forEach(function (mesh) {
                if (meshNamesToAttachTo_1.indexOf(mesh.name) >= 0) {
                    mesh.material = instance.hostInstance;
                }
            });
        }
    };
    MaterialsLifecycleListener.prototype.onParented = function (parent) { };
    MaterialsLifecycleListener.prototype.onChildAdded = function (child) { };
    MaterialsLifecycleListener.prototype.onMount = function (instance) {
        if (instance === undefined) {
            console.error('Missing instance');
            return;
        }
        if (!instance.customProps.attachToMeshesByName) {
            var material_1 = instance.hostInstance;
            var tmp = instance.parent;
            var _loop_1 = function () {
                if (tmp.metadata && tmp.metadata.acceptsMaterials === true) {
                    if (instance.customProps.assignTo) {
                        var propsList_1 = instance.customProps.assignTo.split('.');
                        var propToAssign_1 = tmp.hostInstance;
                        propsList_1.forEach(function (prop, index) {
                            if (propToAssign_1[prop] === undefined) {
                                // create property if it doesn't exist.
                                console.warn('Assign to created property', prop, 'on', propToAssign_1);
                                propToAssign_1[prop] = {};
                            }
                            if (index === propsList_1.length - 1) {
                                propToAssign_1[prop] = material_1;
                            }
                            else {
                                propToAssign_1 = propToAssign_1[prop];
                            }
                        });
                    }
                    else {
                        tmp.hostInstance.material = material_1;
                    }
                    return "break";
                }
                tmp = tmp.parent;
            };
            while (tmp !== null) {
                var state_1 = _loop_1();
                if (state_1 === "break")
                    break;
            }
        }
    };
    MaterialsLifecycleListener.prototype.onUnmount = function () { };
    return MaterialsLifecycleListener;
}());
export default MaterialsLifecycleListener;
//# sourceMappingURL=MaterialsLifecycleListener.js.map