var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { PhysicsImpostor } from "@babylonjs/core";
import DeferredCreationLifecycleListener from "./DeferredCreationLifecycleListener";
/**
 * There is a lot going on in the PhysicsImpostor constructor, so we delay instantiation so that we have a target
 * 'object' before creation.
 */
var PhysicsImpostorLifecycleListener = /** @class */ (function (_super) {
    __extends(PhysicsImpostorLifecycleListener, _super);
    function PhysicsImpostorLifecycleListener(scene, props) {
        var _this = _super.call(this, scene, props) || this;
        _this.createInstance = function (instance, scene, props) {
            if (!_this._parent) {
                return null;
            }
            // these should be set from the props handler.  TODO: test.
            var options = props._options; // constructor has a default { mass: 0 }
            instance.hostInstance = new PhysicsImpostor(_this._parent, props.type, options, _this.scene);
            instance.hostInstance.object = _this._parent;
            _this._parent.physicsImpostor = instance.hostInstance;
            // TODO: need to assign deferredCreationProps (@see ShadowGeneratorLifecycleListener).
            return instance.hostInstance;
        };
        return _this;
    }
    PhysicsImpostorLifecycleListener.prototype.onParented = function (parent, child) {
        // IPhysicsEnabledObject requires only position and rotationQuaternion
        if (parent.hostInstance.position === undefined || parent.hostInstance.rotationQuaternion === undefined) {
            console.warn('PhysicsImpostor is parented to an element that does not appear to implement IPhysicsEnabledObject');
        }
        this._parent = parent.hostInstance;
    };
    PhysicsImpostorLifecycleListener.prototype.onChildAdded = function (child, parent) { };
    PhysicsImpostorLifecycleListener.prototype.onUnmount = function () { };
    return PhysicsImpostorLifecycleListener;
}(DeferredCreationLifecycleListener));
export default PhysicsImpostorLifecycleListener;
//# sourceMappingURL=PhysicsImpostorLifecycleListener.js.map