var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { ShadowGenerator } from "@babylonjs/core";
import DeferredCreationLifecycleListener from "./DeferredCreationLifecycleListener";
var ShadowGeneratorLifecycleListener = /** @class */ (function (_super) {
    __extends(ShadowGeneratorLifecycleListener, _super);
    function ShadowGeneratorLifecycleListener(scene, props) {
        var _this = _super.call(this, scene, props) || this;
        _this.onMeshAddedObservable = null;
        _this.onMeshRemovedObservable = null;
        _this.createInstance = function (instance, scene, props) {
            var tmp = instance.parent;
            var result = null;
            while (tmp !== null) {
                if (tmp.metadata.isShadowLight) {
                    // console.log("Creating ShadowGenerator.  size:", this.props.mapSize, "light", tmp.hostInstance)
                    instance.hostInstance = result = new ShadowGenerator(props.mapSize, tmp.hostInstance, props.useFullFloatFirst);
                    break;
                }
                tmp = tmp.parent;
            }
            if (instance.hostInstance === undefined) {
                console.error("ShadowGenerator has no light source.");
                return null;
            }
            if (instance.customProps.shadowCasters) {
                if (!Array.isArray(instance.customProps.shadowCasters)) {
                    console.error("Shadow casters must be an array (of strings).", instance.customProps.shadowCasters);
                    return null;
                }
                var shadowCasters_1 = instance.customProps.shadowCasters;
                // TODO: also need a listener for models or if we want to add a predicate:
                _this.onMeshAddedObservable = scene.onNewMeshAddedObservable.add(function (mesh) {
                    if (shadowCasters_1.indexOf(mesh.name) >= 0) {
                        instance.hostInstance.addShadowCaster(mesh);
                    }
                });
                _this.onMeshRemovedObservable = scene.onMeshRemovedObservable.add(function (mesh) {
                    if (shadowCasters_1.indexOf(mesh.name) >= 0) {
                        instance.hostInstance.removeShadowCaster(mesh);
                    }
                });
                scene.meshes.forEach(function (mesh) {
                    if (shadowCasters_1.indexOf(mesh.name) >= 0) {
                        instance.hostInstance.addShadowCaster(mesh);
                    }
                });
            }
            else if (instance.customProps.shadowCastersExcluding) {
                if (!Array.isArray(instance.customProps.shadowCastersExcluding)) {
                    console.error("Shadow casters excluding must be an array (of strings).", instance.customProps.shadowCastersExcluding);
                }
                else {
                    var shadowCastersExcluding_1 = instance.customProps.shadowCastersExcluding;
                    // TODO: also need a listener for models or if we want to add a predicate:
                    _this.onMeshAddedObservable = scene.onNewMeshAddedObservable.add(function (mesh) {
                        if (shadowCastersExcluding_1.indexOf(mesh.name) === -1) {
                            instance.hostInstance.addShadowCaster(mesh);
                        }
                    });
                    _this.onMeshRemovedObservable = scene.onMeshRemovedObservable.add(function (mesh) {
                        if (shadowCastersExcluding_1.indexOf(mesh.name) === -1) {
                            instance.hostInstance.removeShadowCaster(mesh);
                        }
                    });
                    scene.meshes.forEach(function (mesh) {
                        if (shadowCastersExcluding_1.indexOf(mesh.name) === -1) {
                            instance.hostInstance.addShadowCaster(mesh);
                        }
                    });
                }
            }
            return result;
        };
        return _this;
    }
    ShadowGeneratorLifecycleListener.prototype.onParented = function (parent, child) { };
    ShadowGeneratorLifecycleListener.prototype.onChildAdded = function (child, parent) { };
    ShadowGeneratorLifecycleListener.prototype.onUnmount = function () {
        if (this.onMeshAddedObservable !== null) {
            this.scene.onNewMeshAddedObservable.remove(this.onMeshAddedObservable);
            this.onMeshAddedObservable = null;
        }
        if (this.onMeshRemovedObservable !== null) {
            this.scene.onMeshRemovedObservable.remove(this.onMeshRemovedObservable);
            this.onMeshRemovedObservable = null;
        }
    };
    return ShadowGeneratorLifecycleListener;
}(DeferredCreationLifecycleListener));
export default ShadowGeneratorLifecycleListener;
//# sourceMappingURL=ShadowGeneratorLifecycleListener.js.map