import { PropChangeType } from "../PropsHandler";
// This does not work when declared component with "lockedTargetMeshName" is before the mesh with that name.
// Need to wait for full commit mount of entire tree, so use in conjunction with LifecycleListner is best option.
var TargetPropsHandler = /** @class */ (function () {
    function TargetPropsHandler(scene) {
        this.scene = scene;
    }
    TargetPropsHandler.prototype.getPropertyUpdates = function (oldProps, newProps) {
        var propertyUpdates = [];
        if (!oldProps.lockedTargetMeshName || oldProps.lockedTargetMeshName !== newProps.lockedTargetMeshName) {
            if (typeof newProps.lockedTargetMeshName === "string") {
                propertyUpdates.push({
                    type: "BabylonjsCoreMesh",
                    value: this.scene.getMeshByName(newProps.lockedTargetMeshName),
                    changeType: PropChangeType.Primitive,
                    propertyName: "lockedTarget"
                });
            }
        }
        return propertyUpdates;
    };
    return TargetPropsHandler;
}());
export default TargetPropsHandler;
//# sourceMappingURL=TargetPropsHandler.js.map