/**
 * This is a host component.  Much like a span or div for ReactDOM.render();
 */
var HostWithEventsFiber = /** @class */ (function () {
    function HostWithEventsFiber(scene, engine, props) {
        this._scene = scene;
        this._engine = engine;
        if (props.onParented && typeof props.onParented === "function") {
            this._onParented = props.onParented;
        }
        if (props.onChildAdded && typeof props.onChildAdded === "function") {
            this._onChildAdded = props.onChildAdded;
        }
        if (props.onMount && typeof props.onMount === "function") {
            this._onMount = props.onMount;
        }
        if (props.onUnmount && typeof props.onUnmount === "function") {
            this._onUnmount = props.onUnmount;
        }
    }
    HostWithEventsFiber.prototype.onParented = function (parent) {
        if (parent !== undefined && this._onParented !== undefined) {
            this._hostContextData = this._onParented(this._scene, this._engine, parent);
        }
    };
    HostWithEventsFiber.prototype.onChildAdded = function (child) {
        if (this._onChildAdded) {
            this._hostContextData = this._onChildAdded(this._scene, this._engine, child, this._hostContextData);
        }
    };
    HostWithEventsFiber.prototype.onMount = function (instance) {
        if (this._onMount) {
            this._hostContextData = this._onMount(this._scene, this._engine, instance, this._hostContextData);
        }
    };
    HostWithEventsFiber.prototype.dispose = function () {
        if (this._onUnmount) {
            this._onUnmount(this._scene, this._engine, this._hostContextData);
        }
    };
    HostWithEventsFiber.prototype.onUnmount = function () { };
    return HostWithEventsFiber;
}());
export default HostWithEventsFiber;
//# sourceMappingURL=hostWithEventsFiber.js.map