var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { FiberMeshPropsHandler, FiberAbstractMeshPropsHandler, FiberTransformNodePropsHandler, FiberNodePropsHandler } from "../generatedCode";
import BasePropsHandler from "../BasePropsHandler";
var FiberModel = /** @class */ (function (_super) {
    __extends(FiberModel, _super);
    function FiberModel() {
        return _super.call(this, [new ModelPropsHandler()]) || this;
    }
    return FiberModel;
}(BasePropsHandler));
export { FiberModel };
var ModelPropsHandler = /** @class */ (function () {
    function ModelPropsHandler() {
    }
    ModelPropsHandler.prototype.getPropertyUpdates = function (oldProps, newProps) {
        var propsHandlers = [
            new FiberMeshPropsHandler(),
            new FiberAbstractMeshPropsHandler(),
            new FiberTransformNodePropsHandler(),
            new FiberNodePropsHandler()
        ];
        var meshUpdates = [];
        propsHandlers.forEach(function (propHandler) {
            // NOTE: this is actually WRONG, because here we want to compare the props with the object.
            var handlerUpdates = propHandler.getPropertyUpdates(oldProps, newProps);
            if (handlerUpdates !== null) {
                meshUpdates.push.apply(meshUpdates, handlerUpdates);
            }
        });
        if (meshUpdates.length === 0) {
            return null;
        }
        // add target
        meshUpdates.forEach(function (propertyUpdate) { return (propertyUpdate.target = "rootMesh"); });
        return meshUpdates;
    };
    return ModelPropsHandler;
}());
export { ModelPropsHandler };
//# sourceMappingURL=ModelProps.js.map